import { iValue } from "../interfaces/ivalue";
import { AppiumResponse } from "./appium-response";
import { JsonDoc } from "../json/jpath";
import { HttpRequestOptions } from "../interfaces/http";
import { FindAllOptions } from "../interfaces/find-options";
import { DeviceProperties } from "../interfaces/device-properties";
import { AppiumScenario } from "./appium-scenario";
export declare const sendAppiumRequest: (scenario: AppiumScenario, path: string, opts: HttpRequestOptions) => Promise<JsonDoc>;
export declare const appiumSessionCreate: (scenario: AppiumScenario, opts?: any) => () => Promise<AppiumScenario>;
export declare const appiumSessionDestroy: (scenario: AppiumScenario, sessionId: string) => Promise<JsonDoc>;
export declare const appiumFindByUiAutomator: (response: AppiumResponse, selector: string, text: string, opts?: FindAllOptions | null | undefined, parent?: string | null | undefined) => Promise<iValue[]>;
export declare const setDevProperties: (sessionId: string, scenario: AppiumScenario, devProperties?: DeviceProperties) => Promise<void>;
export declare const sendAdbCommand: (sessionId: string, scenario: AppiumScenario, command: string, args?: any[] | undefined, timeout?: number, includeStderr?: boolean) => Promise<any>;
export declare const sendSiriCommand: (sessionId: string, scenario: AppiumScenario, command: string) => Promise<void>;
export declare const getSiriEffect: (sessionId: string, scenario: AppiumScenario, setting: string) => Promise<string>;
export declare const siriCommandAndResponse: (sessionId: string, scenario: AppiumScenario, setting: string, isSet: boolean) => Promise<void>;
export declare const setImplicitWait: (sessionId: string, scenario: AppiumScenario, ms: number) => Promise<void>;
export declare const getTimeout: (sessionId: string, scenario: AppiumScenario) => Promise<number>;
