"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppiumScenario = void 0;
const appium_response_1 = require("./appium-response");
const needle_1 = require("../http/needle");
const scenario_1 = require("../scenario");
class AppiumScenario extends scenario_1.ProtoScenario {
    constructor(suite, title, type, opts) {
        super(suite, title, AppiumScenario, opts);
        this.suite = suite;
        this.title = title;
        this.type = type;
        this.adapter = needle_1.fetchWithNeedle;
        this.response = new appium_response_1.AppiumResponse(this);
        this.typeName = "Appium";
        this.open("POST /wd/hub/session", {
            data: {
                capabilities: {
                    alwaysMatch: Object.assign({}, opts.capabilities),
                },
                devProperties: Object.assign({}, opts.devProperties),
            },
        });
    }
}
exports.AppiumScenario = AppiumScenario;
//# sourceMappingURL=appium-scenario.js.map