import { iAssertion } from "../interfaces/iassertion";
import { iAssertionIs } from "../interfaces/iassertion-is";
import validator from "validator";
export declare class AssertionIs implements iAssertionIs {
    private _assertion;
    get not(): AssertionIs;
    get optional(): AssertionIs;
    constructor(_assertion: iAssertion);
    type(type: string): iAssertion;
    array(): iAssertion;
    object(): iAssertion;
    null(): iAssertion;
    undefined(): iAssertion;
    number(): iAssertion;
    string(): iAssertion;
    greaterThan(value: any): iAssertion;
    lessThan(value: any): iAssertion;
    lessThanOrEquals(value: any): iAssertion;
    greaterThanOrEquals(value: any): iAssertion;
    boolean(): iAssertion;
    email(): iAssertion;
    alpha(): iAssertion;
    alphaNumeric(): iAssertion;
    ascii(): iAssertion;
    creditCard(): iAssertion;
    currency(): iAssertion;
    decimal(): iAssertion;
    float(): iAssertion;
    ip(): iAssertion;
    ipRange(): iAssertion;
    isin(): iAssertion;
    isbn(): iAssertion;
    isrc(): iAssertion;
    issn(): iAssertion;
    bic(): iAssertion;
    btcAddress(): iAssertion;
    ean(): iAssertion;
    iban(): iAssertion;
    integer(): iAssertion;
    json(): iAssertion;
    jwt(): iAssertion;
    numeric(): iAssertion;
    postalCode(locale?: validator.PostalCodeLocale): iAssertion;
    url(): iAssertion;
    mobilePhone(locale?: validator.MobilePhoneLocale): iAssertion;
    base32(): iAssertion;
    base64(): iAssertion;
    beforeDate(date?: string): iAssertion;
    sameOrAfterDate(date?: string): iAssertion;
    sameOrBeforeDate(date?: string): iAssertion;
    afterDate(date?: string): iAssertion;
    dataUri(): iAssertion;
    empty(): iAssertion;
    fqdn(): iAssertion;
    hash(): iAssertion;
    hexColor(): iAssertion;
    hexadecimal(): iAssertion;
    hsl(): iAssertion;
    in(values: any[]): iAssertion;
    latLong(): iAssertion;
    lowercase(): iAssertion;
    md5(): iAssertion;
    mimeType(): iAssertion;
    octal(): iAssertion;
    port(): iAssertion;
    rgbColor(): iAssertion;
    slug(): iAssertion;
    strongPassword(): iAssertion;
    uuid(): iAssertion;
    uppercase(): iAssertion;
    date(): iAssertion;
    timezone(): iAssertion;
    regionCode(countries?: ["US" | "CA"]): iAssertion;
    countryCode(format?: "iso-alpha-2" | "iso-alpha-3"): iAssertion;
    private _setValidationMessage;
    private _validate;
    private _validateWithOpts;
}
