"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssertionPromise = void 0;
const util_1 = require("../util");
function assertionMethod(target, methodName, descriptor) {
    descriptor.value = function (...args) {
        const assertionPromise = util_1.cast(this);
        return new AssertionPromise((resolve) => assertionPromise.then((assertion) => {
            resolve(assertion[methodName].apply(assertion, args));
        }));
    };
}
class AssertionPromise extends Promise {
    constructor(executor) {
        super(executor);
    }
    get and() {
        return new AssertionPromise((resolve) => this.then((assertion) => resolve(assertion.and)));
    }
    equals(value) {
        return this;
    }
    exactly(value) {
        return this;
    }
    like(value) {
        return this;
    }
    contains(value) {
        return this;
    }
    greaterThan(value) {
        return this;
    }
    lessThan(value) {
        return this;
    }
    greaterThanOrEquals(value) {
        return this;
    }
    lessThanOrEquals(value) {
        return this;
    }
    between(min, max) {
        return this;
    }
    matches(value) {
        return this;
    }
    startsWith(value) {
        return this;
    }
    endsWith(value) {
        return this;
    }
    continains(values) {
        return this;
    }
    includes(value) {
        return this;
    }
}
__decorate([
    assertionMethod
], AssertionPromise.prototype, "equals", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "exactly", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "like", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "contains", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "greaterThan", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "lessThan", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "greaterThanOrEquals", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "lessThanOrEquals", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "between", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "matches", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "startsWith", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "endsWith", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "continains", null);
__decorate([
    assertionMethod
], AssertionPromise.prototype, "includes", null);
exports.AssertionPromise = AssertionPromise;
//# sourceMappingURL=assertion-promise.js.map