"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("../command");
const cli_1 = require("../cli");
class About extends command_1.Command {
    constructor() {
        super(...arguments);
        this.commandString = "about";
        this.description = "credits";
    }
    action() {
        return __awaiter(this, void 0, void 0, function* () {
            cli_1.Cli.subheader("About Flagpole JS")
                .log("", "Flagpole was created and open sourced by Jason Byrne, during his time as VP of Engineering at FloSports.", "Development continued after Jason left FloSports to join Echelon Fitness as CTO, with contributors from both companies.", "John Sickles, Senior QA Engineer and a leading mind in the field of QA automation, has worked extensively with Jason to make it truly awesome.", "", "Credits:")
                .list("Jason Byrne", "John Sickels", "Russell Brewer", "Arianne Archer", "Karl Snyder", "Alex Pierce", "Will Reynolds", "Aylon Armstrong", "Kyle Babcock")
                .log("", "More info: http://www.flagpolejs.com", "Source: https://www.npmjs.com/package/flagpole", "")
                .exit(0);
        });
    }
}
exports.default = About;
//# sourceMappingURL=about.js.map