"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("../command");
const cli_1 = require("../cli");
const flagpole_execution_1 = require("../../flagpole-execution");
class Debug extends command_1.Command {
    constructor() {
        super(...arguments);
        this.commandString = "debug";
        this.description = "give some debug information";
    }
    action() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            cli_1.Cli.subheader("DEBUG INFO");
            cli_1.Cli.log("", "Settings:")
                .list([
                "Environment: " + ((_a = flagpole_execution_1.FlagpoleExecution.global.environment) === null || _a === void 0 ? void 0 : _a.name),
                "Config file directory: " +
                    flagpole_execution_1.FlagpoleExecution.global.config.getConfigFolder(),
                "Config path: " + flagpole_execution_1.FlagpoleExecution.global.config.getConfigPath(),
                "Project Path: " + flagpole_execution_1.FlagpoleExecution.global.config.getConfigFolder(),
                "Tests Root Path: " + flagpole_execution_1.FlagpoleExecution.global.config.getRootFolder(),
                "Tests Source Path: " +
                    flagpole_execution_1.FlagpoleExecution.global.config.getSourceFolder(),
                "Tests Output Path: " +
                    flagpole_execution_1.FlagpoleExecution.global.config.getTestsFolder(),
                "Base Domain: " + flagpole_execution_1.FlagpoleExecution.global.baseDomain,
                "Output format: " + flagpole_execution_1.FlagpoleExecution.global.outputFormat,
                `Verbosity Volume: ${flagpole_execution_1.FlagpoleExecution.global.volume}%`,
                "Opts: " + flagpole_execution_1.FlagpoleExecution.global.getOptionsString(),
            ])
                .log("")
                .exit(0);
        });
    }
}
exports.default = Debug;
//# sourceMappingURL=debug.js.map