/// <reference types="cheerio" />
import { HttpResponse } from "../http/http-response";
import { iValue } from "../interfaces/ivalue";
import { ValuePromise } from "../value-promise";
import { FindAllOptions, FindOptions } from "../interfaces/find-options";
import { iResponse } from "../interfaces/iresponse";
import { ProtoResponse } from "../response";
export declare class HtmlResponse extends ProtoResponse implements iResponse {
    private _cheerio;
    protected set cheerio(value: cheerio.Root);
    protected get cheerio(): cheerio.Root;
    init(res: HttpResponse): void;
    getRoot(): cheerio.Root;
    find(selector: string, a?: string | RegExp | FindOptions, b?: FindOptions): ValuePromise;
    findAll(selector: string, a?: string | RegExp | FindAllOptions, b?: FindAllOptions): Promise<iValue<cheerio.Element>[]>;
    type(selector: string, textToType: string, opts?: any): ValuePromise;
    clear(selector: string): ValuePromise;
}
