import { NeedleResponse } from "needle";
import { KeyValue } from "../interfaces/generic-types";
import { HttpResponseOptions, iHttpResponse } from "../interfaces/http";
export declare const parseResponseFromLocalFile: (relativePath: string) => Promise<HttpResponse>;
export declare const parseResponseFromNeedle: (response: NeedleResponse) => HttpResponse;
export declare const parseResponsefromJsonData: (jsonBody: any) => HttpResponse;
export declare const createEmptyResponse: () => HttpResponse;
export declare const parseResponseFromString: (body: string) => HttpResponse;
export declare class HttpResponse implements iHttpResponse {
    private opts;
    get method(): string;
    get url(): string;
    get headers(): KeyValue;
    get trailers(): KeyValue;
    get cookies(): KeyValue;
    get statusCode(): number;
    get statusMessage(): string;
    get status(): [statusCode: number, statusMessage: string];
    get body(): string;
    get rawBody(): any;
    get jsonBody(): any;
    constructor(opts: HttpResponseOptions);
}
