"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonScenario = void 0;
const json_response_1 = require("./json-response");
const needle_1 = require("../http/needle");
const scenario_1 = require("../scenario");
const constants_1 = require("../interfaces/constants");
class JsonScenario extends scenario_1.ProtoScenario {
    constructor() {
        super(...arguments);
        this.adapter = needle_1.fetchWithNeedle;
        this.response = new json_response_1.JsonResponse(this);
        this.typeName = "JSON";
        this.defaultRequestOptions = {
            headers: {
                "Content-Type": constants_1.CONTENT_TYPE_JSON,
            },
            method: "get",
        };
    }
}
exports.JsonScenario = JsonScenario;
//# sourceMappingURL=json-scenario.js.map