"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogComment = void 0;
const log_item_1 = require("./log-item");
const console_line_1 = require("./console-line");
const iconsole_log_1 = require("../interfaces/iconsole-log");
class LogComment extends log_item_1.LogItem {
    constructor() {
        super(...arguments);
        this.type = iconsole_log_1.LineType.comment;
        this.className = "comment";
    }
    toHtml() {
        return `
            <li class="${this.className}">
                <span class="message">${this.message}</span>
            </li>
        `;
    }
    toConsole() {
        return [new console_line_1.CommentLine(this.message)];
    }
}
exports.LogComment = LogComment;
//# sourceMappingURL=comment.js.map