"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogScenarioSubHeading = exports.LogScenarioHeading = exports.LogSuiteHeading = void 0;
const log_item_1 = require("./log-item");
const console_line_1 = require("./console-line");
const iconsole_log_1 = require("../interfaces/iconsole-log");
class LogSuiteHeading extends log_item_1.LogItem {
    constructor() {
        super(...arguments);
        this.type = iconsole_log_1.LineType.h1;
        this.className = "heading";
    }
    toHtml() {
        return `
            <h1>${this.message}</h1>
        `;
    }
}
exports.LogSuiteHeading = LogSuiteHeading;
class LogScenarioHeading extends LogSuiteHeading {
    constructor() {
        super(...arguments);
        this.type = iconsole_log_1.LineType.h2;
    }
    toHtml() {
        return `
            <h2>${this.message}</h2>
        `;
    }
    toConsole() {
        return [new console_line_1.SubheadingLine(this.message)];
    }
}
exports.LogScenarioHeading = LogScenarioHeading;
class LogScenarioSubHeading extends LogSuiteHeading {
    constructor() {
        super(...arguments);
        this.type = iconsole_log_1.LineType.h3;
    }
    toHtml() {
        return `
            <li>
                <strong>${this.message}</strong>
            </li>
        `;
    }
    toConsole() {
        return [new console_line_1.SectionHeadingLine(this.message)];
    }
}
exports.LogScenarioSubHeading = LogScenarioSubHeading;
//# sourceMappingURL=heading.js.map