"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchWithFfprobe = void 0;
const http_response_1 = require("../http/http-response");
const media_probe_1 = require("media-probe");
const fetchWithFfprobe = (request, opts) => {
    return new Promise((resolve, reject) => {
        if (!request.uri) {
            return reject("No uri");
        }
        try {
            media_probe_1.ffprobe(request.uri, opts).then((data) => {
                resolve(http_response_1.parseResponsefromJsonData(data));
            });
        }
        catch (err) {
            reject(err);
        }
    });
};
exports.fetchWithFfprobe = fetchWithFfprobe;
//# sourceMappingURL=ffprobe-adapter.js.map