"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MediaResponse = void 0;
const response_1 = require("../response");
class MediaResponse extends response_1.ProtoResponse {
    get extension() {
        return (this.finalUrl.toURL().pathname.split(".").pop() || "").toLowerCase();
    }
    init(httpResponse) {
        super.init(httpResponse);
        this._assertStatusCode();
        this._assertMimeType();
    }
    find(path) {
        throw "This type of scenario does not suport find.";
    }
    findAll(path) {
        return __awaiter(this, void 0, void 0, function* () {
            throw "This type of scenario does not suport findAll.";
        });
    }
    _assertStatusCode() {
        this.context.assert("HTTP Status OK", this.statusCode).between(200, 299);
    }
    _assertMimeType() {
        this.context
            .assert(`MIME Type matches expected value for this type of scenario`, this.header("Content-Type"))
            .matches(this._mimePattern);
    }
}
exports.MediaResponse = MediaResponse;
//# sourceMappingURL=media-response.js.map