"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchWithMediaStreamValidator = void 0;
const http_response_1 = require("../http/http-response");
const media_stream_validator_1 = require("media-stream-validator");
const fetchWithMediaStreamValidator = (request, opts) => {
    return new Promise((resolve, reject) => {
        if (!request.uri) {
            return reject("No uri");
        }
        try {
            media_stream_validator_1.mediaStreamValidator(request.uri, opts).then((data) => {
                resolve(http_response_1.parseResponsefromJsonData(data));
            });
        }
        catch (err) {
            reject(err);
        }
    });
};
exports.fetchWithMediaStreamValidator = fetchWithMediaStreamValidator;
//# sourceMappingURL=media-stream-validator-adapter.js.map