import { iResponse } from "../interfaces/iresponse";
import { FindOptions, FindAllOptions } from "../interfaces/find-options";
import { PointerMove, PointerButton, PointerDisposition } from "../interfaces/pointer";
import { PuppeteerResponse } from "./puppeteer-response";
import { BrowserElement } from "./browser-element";
import { ValuePromise } from "../value-promise";
import { iValue } from "../interfaces/ivalue";
export declare class BrowserResponse extends PuppeteerResponse implements iResponse {
    find(selector: string, a?: string | RegExp | FindOptions, b?: FindOptions): ValuePromise;
    findAll(selector: string, a?: string | RegExp | FindAllOptions, b?: FindAllOptions): Promise<iValue[]>;
    findXPath(xPath: string): ValuePromise;
    findAllXPath(xPath: string): Promise<BrowserElement[]>;
    waitForHidden(selector: string, timeout?: number): ValuePromise;
    waitForVisible(selector: string, timeout?: number): ValuePromise;
    waitForExists(selector: string, timeout?: number): ValuePromise;
    waitForExists(selector: string, contains: string | RegExp, timeout?: number): ValuePromise;
    waitForXPath(xPath: string, timeout?: number): ValuePromise;
    waitForHavingText(selector: string, text: string | RegExp, timeout?: number): ValuePromise;
    waitForNotExists(selector: string, timeout?: number): ValuePromise;
    waitForNotExists(selector: string, contains: string | RegExp, timeout?: number): ValuePromise;
    selectOption(selector: string, value: string | string[]): ValuePromise;
    protected mouseAction(disposition: PointerDisposition, button?: PointerButton): Promise<void>;
    movePointer(...pointers: PointerMove[]): Promise<iResponse>;
}
