import { iAssertionContext } from "../interfaces/iassertioncontext";
import { PuppeteerElement } from "./puppeteer-element";
import { JSHandle, EvaluateFn, SerializableOrJSHandle } from "puppeteer-core";
import { ValuePromise } from "../value-promise";
import { iValue } from "..";
export declare const ExtJsComponentTypes: {
    actionsheet: string;
    audio: string;
    button: string;
    image: string;
    label: string;
    loadmask: string;
    panel: string;
    segmentedbutton: string;
    sheet: string;
    spacer: string;
    titlebar: string;
    toolbar: string;
    video: string;
    carousel: string;
    navigationview: string;
    datepicker: string;
    picker: string;
    slider: string;
    thumb: string;
    tabpanel: string;
    viewport: string;
    dataview: string;
    list: string;
    nestedlist: string;
    checkboxfield: string;
    datepickerfield: string;
    emailfield: string;
    hiddenfield: string;
    numberfield: string;
    passwordfield: string;
    radiofield: string;
    searchfield: string;
    selectfield: string;
    sliderfield: string;
    spinnerfield: string;
    textfield: string;
    textareafield: string;
    togglefield: string;
    treelist: string;
    urlfield: string;
    fieldset: string;
    formpanel: string;
};
export declare class ExtJsComponent extends PuppeteerElement implements iValue {
    protected _input: JSHandle;
    protected _path: string;
    get $(): JSHandle;
    get path(): string;
    get name(): string;
    private get _response();
    private get _isExtComponent();
    static create(handle: JSHandle, context: iAssertionContext, name: string, path: string): Promise<ExtJsComponent>;
    private constructor();
    focus(): ValuePromise;
    hover(): ValuePromise;
    blur(): ValuePromise;
    click(): ValuePromise;
    getAncestor(selector: string): ValuePromise;
    getFirstChild(selector: string): ValuePromise;
    getLastChild(selector: string): ValuePromise;
    getAncestors(selector: string): Promise<iValue[]>;
    find(selector: string): ValuePromise;
    findAll(selector: string): Promise<iValue[]>;
    clear(): ValuePromise;
    type(textToType: string, opts: any): ValuePromise;
    pressEnter(): ValuePromise;
    waitForVisible(timeout?: number): ValuePromise;
    waitForHidden(timeout?: number): ValuePromise;
    isVisible(): Promise<boolean>;
    isHidden(): Promise<boolean>;
    setValue(text: string): ValuePromise;
    getParent(): ValuePromise;
    getSiblings(selector?: string): Promise<iValue[]>;
    getFirstSibling(selector?: string): ValuePromise;
    getLastSibling(selector?: string): ValuePromise;
    getChildren(selector?: string): Promise<iValue[]>;
    getNextSibling(selector: string): ValuePromise;
    getPreviousSibling(selector: string): ValuePromise;
    eval(js: EvaluateFn<any>, ...args: SerializableOrJSHandle[]): Promise<any>;
    selectOption(valuesToSelect: string | string[]): ValuePromise;
    scrollTo(): ValuePromise;
    protected _action(eventName: string): ValuePromise;
    protected _getClassName(): Promise<string>;
    protected _getAttribute(key: string): Promise<string>;
    protected _getTagName(): Promise<string>;
    protected _getInnerText(): Promise<string>;
    protected _getInnerHtml(): Promise<string>;
    protected _getOuterHtml(): Promise<string>;
    protected _getText(): Promise<string>;
    protected _getValue(): Promise<any>;
    protected _isPasswordField(): Promise<boolean>;
}
