import { JSHandle, Page, EvaluateFn } from "puppeteer-core";
import { iAssertionContext } from "../interfaces/iassertioncontext";
import { iValue } from "..";
export declare function jsHandleIsNull(handle: JSHandle<any>): Promise<boolean>;
export declare function jsHandleArrayToHandles(results: JSHandle): Promise<JSHandle<any>[]>;
export declare function jsHandleArrayToComponents(results: JSHandle, context: iAssertionContext, name: string, path: string): Promise<iValue[]>;
export declare function filter(jsHandleArray: JSHandle, filterFunction: EvaluateFn, ...args: any[]): Promise<JSHandle[]>;
export declare function queryAllDomElementsWithinComponent(component: JSHandle, selector: string): Promise<JSHandle<any>>;
export declare function queryDomElementWithinComponent(component: JSHandle, selector: string): Promise<JSHandle<any> | null>;
export declare function query(page: Page, selector: string): Promise<JSHandle<any>>;
export declare function queryWithinComponent(component: JSHandle, selector: string): Promise<JSHandle<any>>;
export declare function id(component: JSHandle): Promise<JSHandle<any>>;
export declare function down(context: JSHandle, selector: string): Promise<JSHandle | null>;
export declare function child(context: JSHandle, selector: string): Promise<JSHandle<any> | null>;
export declare function up(context: JSHandle, selector: string): Promise<JSHandle<any> | null>;
export declare function parent(context: JSHandle): Promise<JSHandle<any> | null>;
export declare function ancestors(context: JSHandle, selector: string): Promise<JSHandle<any>>;
export declare function jsHandleToComponent(handle: JSHandle<any> | null, context: iAssertionContext, name: string, path: string): Promise<iValue>;
