import { ExtJsComponent } from "./extjs-component";
import { iResponse } from "../interfaces/iresponse";
import { FindOptions, FindAllOptions } from "../interfaces/find-options";
import { PuppeteerResponse } from "./puppeteer-response";
import { EvaluateFn } from "puppeteer-core";
import { ValuePromise } from "../value-promise";
import { ExtJsScenario } from "./extjs-scenario";
import { iValue } from "../interfaces/ivalue";
export declare class ExtJSResponse extends PuppeteerResponse implements iResponse {
    constructor(scenario: ExtJsScenario);
    findXPath(xPath: string): ValuePromise;
    findAllXPath(xPath: string): Promise<iValue[]>;
    waitForExists(path: string, a?: number | string | RegExp, b?: number): ValuePromise;
    type(selector: string, textToType: string, opts?: any): ValuePromise;
    clear(selector: string): ValuePromise;
    getComponentById(id: string): Promise<ExtJsComponent | null>;
    protected _getComponent(js: EvaluateFn<any>, name: string, path: string): Promise<import("..").Value<null> | ExtJsComponent>;
    private _injectScript;
    find(selector: string, a?: string | RegExp | FindOptions, b?: FindOptions): ValuePromise;
    findAll(selector: string, a?: string | RegExp | FindAllOptions, b?: FindAllOptions): Promise<iValue[]>;
    selectOption(selector: string, value: string | string[]): ValuePromise;
    private _getComponentOrElementFromHandle;
    private _getComponentFromElementHandle;
    private _query;
}
