import { ProtoScenario } from "../scenario";
import { ScenarioDisposition } from "../interfaces/enums";
import { BrowserControl } from "./browser-control";
import { KeyValue } from "../interfaces/generic-types";
import { Browser, Page } from "puppeteer-core";
import { ExtJSResponse } from "./extjs-response";
import { BrowserOptions } from "./browser-opts";
export declare class ExtJsScenario extends ProtoScenario {
    readonly adapter: import("../interfaces/http").HttpAdapter;
    readonly response: ExtJSResponse;
    readonly typeName = "ExtJS";
    readonly defaultRequestOptions: BrowserOptions;
    protected _browserControl: BrowserControl | null;
    get browserControl(): BrowserControl | null;
    get browser(): Browser | null;
    get page(): Page | null;
    protected _executeHttpRequest(): void;
    protected _getRequestOptions(opts?: KeyValue): KeyValue;
    private _executeBrowserRequest;
    protected _markScenarioCompleted(message?: string | null, details?: string | null, disposition?: ScenarioDisposition): Promise<this>;
}
