/// <reference types="node" />
import { Page, Browser, Response, EvaluateFn, SerializableOrJSHandle, PageFnOptions } from "puppeteer-core";
import { iResponse } from "../interfaces/iresponse";
import { BrowserControl } from "./browser-control";
import { ValuePromise } from "../value-promise";
import { BrowserScenario } from "./browser-scenario";
import { ExtJsScenario } from "./extjs-scenario";
import { ScreenshotOpts } from "../interfaces/screenshot";
import { iHttpRequest } from "../interfaces/http";
import { iValue } from "../interfaces/ivalue";
import { ProtoResponse } from "../response";
export declare abstract class PuppeteerResponse extends ProtoResponse implements iResponse {
    readonly scenario: BrowserScenario | ExtJsScenario;
    constructor(scenario: BrowserScenario | ExtJsScenario);
    get browserControl(): BrowserControl | null;
    get page(): Page | null;
    get browser(): Browser | null;
    get response(): Response | null;
    get currentUrl(): iValue;
    protected get _page(): Page;
    eval(js: EvaluateFn<any>, ...args: SerializableOrJSHandle[]): Promise<any>;
    waitForNetworkIdle(timeout?: number): Promise<void>;
    waitForNavigation(timeout?: number, waitFor?: string | string[]): Promise<void>;
    waitForLoad(timeout?: number): Promise<void>;
    waitForFunction(js: EvaluateFn<any>, opts?: PageFnOptions, ...args: SerializableOrJSHandle[]): Promise<void>;
    waitForReady(timeout?: number): Promise<void>;
    screenshot(): Promise<Buffer>;
    screenshot(localFilePath: string): Promise<Buffer>;
    screenshot(localFilePath: string, opts: ScreenshotOpts): Promise<Buffer>;
    screenshot(opts: ScreenshotOpts): Promise<Buffer>;
    clearThenType(selector: string, textToType: string, opts?: any): ValuePromise;
    type(selector: string, textToType: string, opts?: any): ValuePromise;
    clear(selector: string): ValuePromise;
    scrollTo(point: {
        x: number;
        y: number;
    }): Promise<iResponse>;
    protected getTimeoutFromOverload(a: any, b?: any): number;
    protected getContainsPatternFromOverload(contains: any): RegExp | null;
    navigate(req: iHttpRequest): Promise<void>;
}
