"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createScenario = exports.ScenarioTypeMap = void 0;
const appium_scenario_1 = require("./appium/appium-scenario");
const json_scenario_1 = require("./json/json-scenario");
const browser_scenario_1 = require("./puppeteer/browser-scenario");
const extjs_scenario_1 = require("./puppeteer/extjs-scenario");
const html_scenario_1 = require("./html/html-scenario");
const image_scenario_1 = require("./visual/image-scenario");
const xml_scenario_1 = require("./xml/xml-scenario");
const rss_scenario_1 = require("./xml/rss-scenario");
const atom_scenario_1 = require("./xml/atom-scenario");
const soap_scenario_1 = require("./xml/soap-scenario");
const headers_scenario_1 = require("./headers/headers-scenario");
const hls_scenario_1 = require("./media/hls-scenario");
const ffprobe_scenario_1 = require("./media/ffprobe-scenario");
const resource_scenario_1 = require("./resource/resource-scenario");
const media_stream_validator_scenario_1 = require("./media/media-stream-validator-scenario");
exports.ScenarioTypeMap = {
    html: html_scenario_1.HtmlScenario,
    browser: browser_scenario_1.BrowserScenario,
    extjs: extjs_scenario_1.ExtJsScenario,
    image: image_scenario_1.ImageScenario,
    json: json_scenario_1.JsonScenario,
    xml: xml_scenario_1.XmlScenario,
    rss: rss_scenario_1.RssScenario,
    atom: atom_scenario_1.AtomScenario,
    soap: soap_scenario_1.SoapScenario,
    headers: headers_scenario_1.HeadersScenario,
    hls: hls_scenario_1.HlsScenario,
    ffprobe: ffprobe_scenario_1.FfprobeScenario,
    resource: resource_scenario_1.ResourceScenario,
    mediastreamvalidator: media_stream_validator_scenario_1.MediaStreamValidatorScenario,
    appium: appium_scenario_1.AppiumScenario,
};
const createScenario = (suite, title, type, opts) => {
    const ctor = typeof type == "string" ? exports.ScenarioTypeMap[type] : type;
    return new ctor(suite, title, ctor, opts);
};
exports.createScenario = createScenario;
//# sourceMappingURL=scenario-type-map.js.map