import { ProtoResponse } from "../response";
import { iResponse } from "../interfaces/iresponse";
import { HttpResponse } from "../http/http-response";
import { ValuePromise } from "../value-promise";
import { iValue } from "../interfaces/ivalue";
export interface ImageProperties {
    width: number;
    height: number;
    type: string;
    mime: string;
    length: number;
    url: string;
}
export declare class ImageResponse extends ProtoResponse implements iResponse {
    protected imageProperties: ImageProperties;
    get length(): iValue;
    get url(): iValue;
    get path(): iValue;
    init(httpResponse: HttpResponse): void;
    eval(): Promise<any>;
    find(propertyName: string): ValuePromise;
    findAll(propertyName: string): Promise<iValue[]>;
}
