"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SoapScenario = void 0;
const constants_1 = require("../interfaces/constants");
const needle_1 = require("../http/needle");
const scenario_1 = require("../scenario");
const soap_response_1 = require("./soap-response");
class SoapScenario extends scenario_1.ProtoScenario {
    constructor() {
        super(...arguments);
        this.adapter = needle_1.fetchWithNeedle;
        this.response = new soap_response_1.SoapResponse(this);
        this.typeName = "SOAP";
    }
    _getDefaultRequestOptions() {
        const headers = {};
        headers["Content-Type"] = constants_1.CONTENT_TYPE_SOAP;
        return {
            method: "post",
            headers,
        };
    }
}
exports.SoapScenario = SoapScenario;
//# sourceMappingURL=soap-scenario.js.map