"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XmlResponse = void 0;
const html_response_1 = require("../html/html-response");
const cheerio = require("cheerio");
class XmlResponse extends html_response_1.HtmlResponse {
    init(httpResponse) {
        super.init(httpResponse);
        this.cheerio = cheerio.load(httpResponse.body, {
            xmlMode: true,
        });
    }
    normalizeSelector(selector) {
        return selector.replace(/([a-z0-9]):([a-z0-9])/gi, "$1\\:$2");
    }
    find(selector, a, b) {
        return super.find(this.normalizeSelector(selector), a, b);
    }
    findAll(selector, a, b) {
        const _super = Object.create(null, {
            findAll: { get: () => super.findAll }
        });
        return __awaiter(this, void 0, void 0, function* () {
            return _super.findAll.call(this, this.normalizeSelector(selector), a, b);
        });
    }
}
exports.XmlResponse = XmlResponse;
//# sourceMappingURL=xml-response.js.map